(*

(C) 2008-2013 Alexander Myasnikov
 --= RSD implementation =--

Web: ru-steganography.narod.ru 

e-mail: amsoftware@ya.ru
 
*)  
  
program rsd;

{$APPTYPE CONSOLE}


uses
  System.SysUtils, Classes,
  amprng10 in 'amprng10.pas';

procedure rsdcode(inf, outf, pwd: String);
var
  buf1, buf2: array of byte;
  Size, i: integer;
  idx: LongWord;
  am: TAMPRNG;
  f1, f2: TFileStream;
  used: array of boolean;
begin

  f1 := TFileStream.Create(inf, fmOpenRead);
  f2 := TFileStream.Create(outf, fmCreate);

  Size := f1.Size;

  SetLength(buf1, Size);
  SetLength(buf2, Size);
  SetLength(used, Size);

  f1.Read(buf1[0], Size);

  for i := 0 to Size - 1 do
    used[i] := False;

  am := TAMPRNG.Create(pwd, 64, 4096);

  for i := 0 to Size - 1 do

  begin
    repeat
      idx := am.RandomU32 mod Size;
    until used[idx] = False;

    used[idx] := true;
    buf2[i] := buf1[idx];
  end;

  am.Free;

  f2.Write(buf2[0], Size);

  f1.Free;
  f2.Free;

end;

procedure rsddecode(inf, outf, pwd: String);
var
  buf1, buf2: array of byte;
  Size, i: integer;
  idx: LongWord;
  am: TAMPRNG;
  f1, f2: TFileStream;
  used: array of boolean;
begin

  f1 := TFileStream.Create(inf, fmOpenRead);
  f2 := TFileStream.Create(outf, fmCreate);

  Size := f1.Size;

  SetLength(buf1, Size);
  SetLength(buf2, Size);
  SetLength(used, Size);

  f1.Read(buf1[0], Size);

  for i := 0 to Size - 1 do
    used[i] := False;

  am := TAMPRNG.Create(pwd, 64, 4096);

  for i := 0 to Size - 1 do

  begin
    repeat
      idx := am.RandomU32 mod Size;
    until used[idx] = False;

    used[idx] := true;
    buf2[idx] := buf1[i];
  end;

  am.Free;

  f2.Write(buf2[0], Size);

  f1.Free;
  f2.Free;

end;

begin
  try

    if paramstr(1) = '-e' then
      rsdcode(paramstr(2), paramstr(3), paramstr(4))
    else if paramstr(1) = '-d' then
      rsddecode(paramstr(2), paramstr(3), paramstr(4));

  except
    on E: Exception do
      Writeln(E.ClassName, ': ', E.Message);
  end;

end.
